'use strict';

const path = require('path');

// https://babeljs.io/docs/plugins/
const plugins = [
    require.resolve('babel-plugin-check-es2015-constants'),
    require.resolve('babel-plugin-syntax-trailing-function-commas'),
    require.resolve('babel-plugin-transform-async-to-generator'),
    require.resolve('babel-plugin-transform-es2015-arrow-functions'),
    require.resolve('babel-plugin-transform-es2015-block-scoped-functions'),
    [require.resolve('babel-plugin-transform-es2015-block-scoping', {
        throwIfClosureRequired: true
    })],
    [require.resolve('babel-plugin-transform-es2015-classes', {
        loose: false
    })],
    [require.resolve('babel-plugin-transform-es2015-computed-properties', {
        loose: false
    })],
    require.resolve('babel-plugin-transform-es2015-destructuring'),
    require.resolve('babel-plugin-transform-es2015-duplicate-keys'),
    [require.resolve('babel-plugin-transform-es2015-for-of', {
        loose: false
    })],
    require.resolve('babel-plugin-transform-es2015-function-name'),
    require.resolve('babel-plugin-transform-es2015-literals'),
    require.resolve('babel-plugin-transform-es2015-object-super'),
    require.resolve('babel-plugin-transform-es2015-parameters'),
    require.resolve('babel-plugin-transform-es2015-shorthand-properties'),
    [require.resolve('babel-plugin-transform-es2015-spread', {
        loose: false
    })],
    require.resolve('babel-plugin-transform-es2015-sticky-regex'),
    [require.resolve('babel-plugin-transform-es2015-template-literals', {
        loose: false,
        spec: true
    })],
    require.resolve('babel-plugin-transform-es2015-typeof-symbol'),
    require.resolve('babel-plugin-transform-es2015-unicode-regex'),
    require.resolve('babel-plugin-transform-exponentiation-operator'),
    [require.resolve('babel-plugin-transform-regenerator', {
        asyncGenerators: true,
        generators: true,
        async: true
    })],
    require.resolve('babel-plugin-undeclared-variables-check'),
    require.resolve('babel-plugin-transform-flow-comments'),
    require.resolve('babel-plugin-dynamic-import-node'),
    [require.resolve('babel-plugin-transform-runtime', {
        helpers: false,
        polyfill: true,
        regenerator: false,
        moduleName: path.dirname(require.resolve('babel-runtime/package'))
    })],
];

module.exports = {
    presets: [
        require.resolve('babel-preset-flow'),
        [require.resolve('babel-preset-env'), {
            targets: {
                // React parses on ie 9, so we should too
                ie: 9,
                // We currently minify with uglify
                // Remove after https://github.com/mishoo/UglifyJS2/issues/448
                uglify: true
            },
            // Disable polyfill transforms
            useBuiltIns: false }]
    ],
    plugins: plugins
};




